      SUBROUTINE EF03R(M,N,A,F,DELTA,H,D,P1,P2,P3,P4,L,U,B)
         INTEGER L,M,N
         REAL A,B,D,DELTA,F,H,P1,P2,P3,P4,U
         DIMENSION A(M,N),B(1),D(N),DELTA(M),F(M),H(N),U(N)
         INTEGER I,I1,I2,I3,I4,I5,IM,IP,IS,IXP,J,K,K1,K2,K3,K4,K5,NP
         REAL ABS,AVZ2R,R,S,SIGN,SQRT,W,W1
      EXTERNAL AVZ2R
       K = N + N
       K1 = K + N
       K2 = 3*N + M
       K3 = K2 + M
       K4 = K3 + N
       K5 = K4 + N
       GO TO (10,40),L
   10  CONTINUE
       CALL EF03R1(N,P1,P2,P3,H,D,B(1),B(N+1),B(K+1))
       CALL EF03R2(N,B(1),B(N+1),B(K+1))
       CALL EF03R3(M,N,A,D,B(1),B(N+1),B(K+1))
       DO 30 I = 1, M
          I1 = K1 + I
          B(I1) = 0.
          DO 20 J = 1, N
             B(I1) = B(I1) + A(I,J)*A(I,J)
   20     CONTINUE
   30  CONTINUE
   40  CONTINUE
       DO 50 J = 1, N
          U(J) = 0.
   50  CONTINUE
       IS = 0
   60  CONTINUE
       IP = 0
   70  CONTINUE
       NP = 1
       DO 90 I = 1, M
          I2 = K2 + I
          B(I2) = 0.
          DO 80 J = 1, N
             B(I2) = B(I2) + A(I,J)*U(J)
   80     CONTINUE
   90  CONTINUE
  100  CONTINUE
       DO 140 I = 1, M
          I1 = K1 + I
          I2 = K2 + I
          I5 = K5 + I
          B(I5) = ABS(B(I2) - F(I)) - DELTA(I)
          IF (B(I5) - 1.E-4*DELTA(I)) 130, 130, 110
  110     CONTINUE
          B(I5) = B(I5)/SQRT(B(I1))
          W1 = 0.1*DELTA(I)/SQRT(B(I1))
          IF (B(I5) - W1) 140, 140, 120
  120     CONTINUE
          NP = 2
          GO TO 140
  130     CONTINUE
          B(I5) = 0.
  140  CONTINUE
       GO TO (320,150),NP
  150  CONTINUE
       IF (IS - N) 180, 180, 160
  160  CONTINUE
       IS = 0
       DO 170 I = 1, M
          DELTA(I) = DELTA(I) + P4*DELTA(I)
  170  CONTINUE
       GO TO 40
  180  CONTINUE
       R = AVZ2R(B(K5+1),M,1,IM)
       IM = IM
  190  CONTINUE
       I1 = K1 + IM
       I2 = K2 + IM
       W = B(I2) - F(IM)
       S = R*SIGN(1.,W)/SQRT(B(I1))
       DO 200 J = 1, N
          U(J) = U(J) - S*A(IM,J)
  200  CONTINUE
       IP = IP + 1
       GO TO (210,230,290),IP
  210  CONTINUE
       IXP = IM
       DO 220 J = 1, N
          I3 = K3 + J
          B(I3) = U(J)
  220  CONTINUE
       GO TO 70
  230  CONTINUE
       R = 0.
       DO 240 J = 1, N
          R = R + A(IXP,J)*U(J)
  240  CONTINUE
       I2 = K2 + IXP
       I1 = K1 + IXP
       B(I2) = R
       W = ABS(R-F(IXP)) - DELTA(IXP)
       IF (W - 1.E-4*DELTA(IXP)) 250, 250, 260
  250  CONTINUE
       R = 0.
       GO TO 270
  260  CONTINUE
       R = W/SQRT(B(I1))
  270  CONTINUE
       IM = IXP
       DO 280 J = 1, N
          I4 = K4 + J
          B(I4) = U(J)
  280  CONTINUE
       GO TO 190
  290  CONTINUE
       R = 0.
       W = 0.
       DO 300 J = 1, N
          I3 = K3 + J
          I4 = K4 + J
          S = B(I3) - B(I4)
          R = R + S*S
          W = W + S*(B(I3) - U(J))
  300  CONTINUE
       W = R/W
       DO 310 J = 1, N
          I3 = K3 + J
          U(J) = B(I3) + W*(U(J) - B(I3))
  310  CONTINUE
       IS = IS + 1
       GO TO 60
  320  CONTINUE
       CALL EF03R4(U,N,B(1),B(N+1),B(K+1))
       RETURN
      END
